## rpma 1.0.0

=== CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2022, Intel Corporation
#

cmake_minimum_required(VERSION 3.3)

project(rpma C)

set(VERSION_MAJOR 1)
set(VERSION_MINOR 0)
set(VERSION_PATCH 0)
# set(VERSION_PRERELEASE rc1)

set(VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
if (VERSION_PRERELEASE)
	set(VERSION ${VERSION}-${VERSION_PRERELEASE})
endif()

set(LIBRPMA_LIBRARIES rpma)
set(LIBRPMA_LIBRARY_DIRS ${CMAKE_BINARY_DIR}/src/)
set(LIBRPMA_INCLUDE_DIRS ${CMAKE_SOURCE_DIR}/src/include/)
set(LIBRPMA_SOURCE_DIR ${CMAKE_SOURCE_DIR}/src/)

# required only for some examples
set(LIBPMEM_REQUIRED_VERSION 1.6)
set(LIBPMEM2_REQUIRED_VERSION 1.10)

set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

include(FindPerl)
include(FindThreads)
include(CMakePackageConfigHelpers)
include(GNUInstallDirs)
include(${CMAKE_SOURCE_DIR}/cmake/functions.cmake)

option(BUILD_DOC "build documentation" ON)
option(BUILD_TESTS "build tests" ON)
option(BUILD_EXAMPLES "build examples" ON)
option(BUILD_DEVELOPER_MODE "enable developer checks" OFF)

option(TESTS_COVERAGE "run coverage test" OFF)
option(TESTS_NO_FORTIFY_SOURCE "enable tests that do not pass when -D_FORTIFY_SOURCE=2 flag set" OFF)
option(TESTS_PERF_TOOLS "run tests for the performance analysis tools" OFF)
option(TESTS_RDMA_CONNECTION "enable tests that require a configured RDMA-capable network interface (valgrind required)" OFF)
option(TESTS_USE_FORCED_PMEM "run tests with PMEM_IS_PMEM_FORCE=1" OFF)
option(TESTS_USE_VALGRIND_PMEMCHECK "enable tests with valgrind pmemcheck (if found)" OFF)
option(TESTS_VERBOSE_OUTPUT "verbose test outputs" OFF)

option(DEBUG_LOG_TRACE "enable logging function traces" OFF)
option(DEBUG_FAULT_INJECTION "enable fault injection" OFF)
option(DEBUG_USE_ASAN "enable AddressSanitizer (-fsanitize=address)" OFF)
option(DEBUG_USE_UBSAN "enable UndefinedBehaviorSanitizer (-fsanitize=undefined)" OFF)

# Do not treat include directories from the interfaces
# of consumed Imported Targets as SYSTEM by default.
set(CMAKE_NO_SYSTEM_FROM_IMPORTED 1)

set(TEST_DIR ${CMAKE_CURRENT_BINARY_DIR}/test
	CACHE STRING "working directory for tests")

set(buildTypes Release Debug RelWithDebInfo MinSizeRel)

if(NOT CMAKE_BUILD_TYPE)
	message(STATUS "No build type selected (CMAKE_BUILD_TYPE), defaulting to Release")
	set(CMAKE_BUILD_TYPE "Release" CACHE STRING
		"Choose the type of build, options are: Release Debug RelWithDebInfo MinSizeRel ..." FORCE)
	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS ${buildTypes})
else()
	message(STATUS "CMAKE_BUILD_TYPE: ${CMAKE_BUILD_TYPE}")
	if(NOT CMAKE_BUILD_TYPE IN_LIST buildTypes)
		message(WARNING "Unusual build type was set, please make sure it's a proper one. "
			"Only following are supported by default: ${buildTypes}.")
	endif()
endif()

if(EXISTS "${CMAKE_SOURCE_DIR}/.git")
	execute_process(COMMAND git describe
			OUTPUT_VARIABLE SRCVERSION
			WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
			OUTPUT_STRIP_TRAILING_WHITESPACE
			ERROR_QUIET)
	if(NOT SRCVERSION)
		execute_process(COMMAND git log -1 --format=%h
				OUTPUT_VARIABLE SRCVERSION
				WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
				OUTPUT_STRIP_TRAILING_WHITESPACE)
	endif()
else()
	execute_process(COMMAND cat .version
			OUTPUT_VARIABLE SRCVERSION
			WORKING_DIRECTORY ${CMAKE_SOURCE_DIR}
			OUTPUT_STRIP_TRAILING_WHITESPACE)
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/cmake)

find_package(PkgConfig REQUIRED)

if(NOT PERL_FOUND)
	message(FATAL_ERROR "Perl not found")
endif()

pkg_check_modules(LIBIBVERBS libibverbs)
if(NOT LIBIBVERBS_FOUND)
	find_package(LIBIBVERBS REQUIRED libibverbs)
endif()

pkg_check_modules(LIBRDMACM librdmacm)
if(NOT LIBRDMACM_FOUND)
	find_package(LIBRDMACM REQUIRED librdmacm)
endif()

pkg_check_modules(LIBPMEM libpmem>=${LIBPMEM_REQUIRED_VERSION})
if(NOT LIBPMEM_FOUND)
	find_package(LIBPMEM ${LIBPMEM_REQUIRED_VERSION})
endif()

pkg_check_modules(LIBPMEM2 libpmem2>=${LIBPMEM2_REQUIRED_VERSION})
if(NOT LIBPMEM2_FOUND)
	find_package(LIBPMEM2 ${LIBPMEM2_REQUIRED_VERSION})
endif()

if(NOT LIBPMEM2_FOUND)
	if(NOT LIBPMEM_FOUND)
		message(WARNING "Since libpmem2 and libpmem are missing, the examples will be unable to use PMem. They will be using DRAM instead.")
	else()
		message(STATUS "libpmem will be used for examples that use PMem.")
	endif()
else()
	# XXX adjust message when all examples are adapted to libpmem2
	# message(STATUS "libpmem2 will be used for examples that use PMem.")
	if(NOT LIBPMEM_FOUND)
		message(WARNING "Since libpmem is missing, the examples that are adapted only to libpmem will be unable to use PMem. They will be using DRAM instead.")
		message(STATUS "libpmem2 will be used for examples that use PMem and are adapted to libpmem2.")
	else()
		message(STATUS "libpmem2 will be used for examples that use PMem and are adapted to libpmem2, otherwise libpmem will be used.")
	endif()
endif()

pkg_check_modules(LIBPROTOBUFC libprotobuf-c)

# check if libibverbs has ODP support
is_ODP_supported(ON_DEMAND_PAGING_SUPPORTED)
if(ON_DEMAND_PAGING_SUPPORTED)
	message(STATUS "On-Demand Paging (ODP) in libibverbs supported - Success")
	add_flag(-DON_DEMAND_PAGING_SUPPORTED=1)
else()
	message(WARNING "On-Demand Paging (ODP) is NOT supported and will be disabled (too old version of libibverbs)!")
endif()

# check if libibverbs has ibv_advise_mr() support
is_ibv_advise_mr_supported(IBV_ADVISE_MR_SUPPORTED)
if(IBV_ADVISE_MR_SUPPORTED)
	message(STATUS "ibv_advise_mr() supported in libibverbs - Success")
	add_flag(-DIBV_ADVISE_MR_SUPPORTED=1)
else()
	message(WARNING "ibv_advise_mr() is NOT supported and will be disabled (too old version of libibverbs)!")
endif()

# check if all required IBV_ADVISE_MR* flags are supported
are_ibv_advise_flags_supported(IBV_ADVISE_MR_FLAGS_SUPPORTED)

# check if librdmacm has correct signature of rdma_getaddrinfo()
check_signature_rdma_getaddrinfo(RDMA_GETADDRINFO_NEW_SIGNATURE)
if(RDMA_GETADDRINFO_NEW_SIGNATURE)
	message(STATUS "Using a new signature of rdma_getaddrinfo()")
else()
	message(STATUS "Using an old signature of rdma_getaddrinfo()")
	add_flag(-DRDMA_GETADDRINFO_OLD_SIGNATURE=1)
endif()

# check if atomic operations are supported
atomic_operations_supported(ATOMIC_OPERATIONS_SUPPORTED)
if(ATOMIC_OPERATIONS_SUPPORTED)
	message(STATUS "atomic operations are supported")
	add_flag(-DATOMIC_OPERATIONS_SUPPORTED=1)
else()
	message(WARNING "atomic operations are NOT supported (too old gcc/clang compiler). Some *_set*() functions will NOT be thread-safe!")
endif()

add_custom_target(checkers ALL)
add_custom_target(cstyle)
add_custom_target(check-whitespace)
add_custom_target(check-license
	COMMAND ${CMAKE_SOURCE_DIR}/utils/check_license/check-headers.sh
		${CMAKE_SOURCE_DIR}
		BSD-3-Clause)

add_custom_target(check-commits
	COMMAND ${CMAKE_SOURCE_DIR}/utils/check-commits.sh)

add_custom_target(check-whitespace-main
	COMMAND ${PERL_EXECUTABLE}
		${CMAKE_SOURCE_DIR}/utils/check_whitespace
		${CMAKE_SOURCE_DIR}/utils/check_license/*
		${CMAKE_SOURCE_DIR}/README.md)

add_dependencies(check-whitespace check-whitespace-main)

add_flag(-Wpointer-arith)
add_flag(-Wunused-macros)
add_flag(-Wsign-conversion)
add_flag(-Wsign-compare)
add_flag(-Wunreachable-code-return)
add_flag(-Wmissing-variable-declarations)
add_flag(-fno-common)
add_flag(-std=gnu11)
add_flag(-ggdb DEBUG)
add_flag(-DDEBUG DEBUG)
add_flag("-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2" RELEASE)

if(DEBUG_USE_ASAN)
	add_sanitizer_flag(address)
endif()

if(DEBUG_USE_UBSAN)
	add_sanitizer_flag(undefined)
endif()

if(TESTS_COVERAGE)
       set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} -coverage")
endif()

if(BUILD_DEVELOPER_MODE)
	set(TESTS_NO_FORTIFY_SOURCE ON)

	add_flag(-Wall)
	add_flag(-Werror)

	add_dependencies(checkers cstyle)
	add_dependencies(checkers check-whitespace)
	add_dependencies(checkers check-license)
	add_dependencies(checkers check-commits)
endif()

add_check_whitespace(cmake-main ${CMAKE_CURRENT_SOURCE_DIR}/CMakeLists.txt)
add_check_whitespace(cmake-helpers ${CMAKE_CURRENT_SOURCE_DIR}/cmake/*.cmake)

configure_file(${CMAKE_SOURCE_DIR}/cmake/librpma.pc.in
	${CMAKE_CURRENT_BINARY_DIR}/librpma.pc @ONLY)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/librpma.pc
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)

configure_file(
	"${CMAKE_SOURCE_DIR}/cmake/cmake_uninstall.cmake.in"
	"${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
	IMMEDIATE @ONLY)

add_custom_target(uninstall
	COMMAND ${CMAKE_COMMAND} -P ${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake)

configure_package_config_file(${CMAKE_SOURCE_DIR}/cmake/librpma-config.cmake.in
	${CMAKE_CURRENT_BINARY_DIR}/librpma-config.cmake
	INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/librpma/cmake
	PATH_VARS CMAKE_INSTALL_LIBDIR CMAKE_INSTALL_INCLUDEDIR)

write_basic_package_version_file(librpma-config-version.cmake
				VERSION ${VERSION}
				COMPATIBILITY AnyNewerVersion)

install(FILES ${CMAKE_CURRENT_BINARY_DIR}/librpma-config.cmake ${CMAKE_CURRENT_BINARY_DIR}/librpma-config-version.cmake
	DESTINATION ${CMAKE_INSTALL_LIBDIR}/librpma/cmake)

pkg_check_modules(VALGRIND valgrind)

if(VALGRIND_FOUND)
	include_directories(${VALGRIND_INCLUDE_DIRS})

	# sets VALGRIND_S_OPTION to "-s" if valgrind supports it or "" otherwise
	valgrind_check_s_option()

	add_flag(-DVG_MEMCHECK_ENABLED=1)
	add_flag(-DVG_DRD_ENABLED=1)
	add_flag(-DVG_HELGRIND_ENABLED=1)

	if(TESTS_USE_VALGRIND_PMEMCHECK)
		find_pmemcheck()
	endif()
	if(VALGRIND_PMEMCHECK_FOUND)
		add_flag(-DVG_PMEMCHECK_ENABLED=1)
	endif()
else()
	if(TESTS_RDMA_CONNECTION)
		message(FATAL_ERROR "Valgrind not found! - tests requiring a configured RDMA-capable network interface"
				"(all multi-threaded and integration tests) require also valgrind to be installed."
				"Install valgrind or set TESTS_RDMA_CONNECTION to OFF.")
	else()
		message(STATUS "NOTICE: valgrind not found! - the tests requiring valgrind "
				"(all multi-threaded and integration tests) will not be run!")
	endif()
endif()

add_subdirectory(src)

if(BUILD_TESTS)
	if(TEST_DIR)
		enable_testing()
	else()
		message(WARNING "TEST_DIR is empty - 'make test' will not work")
	endif()

	add_subdirectory(tests)
endif()

if(BUILD_DOC)
	add_subdirectory(doc)
endif()

if(BUILD_EXAMPLES)
	add_subdirectory(examples)
endif()

if(TESTS_PERF_TOOLS)
	find_package(PYLINT REQUIRED pylint)
	add_subdirectory(tools/perf)
endif()

if(NOT "${CPACK_GENERATOR}" STREQUAL "")
	include(${CMAKE_SOURCE_DIR}/cmake/packages.cmake)
endif()

add_custom_target(config_softroce
	COMMAND ${CMAKE_SOURCE_DIR}/tools/config_softroce.sh)

add_custom_target(run_all_examples
	COMMAND ${CMAKE_SOURCE_DIR}/examples/run-all-examples.sh ${CMAKE_BINARY_DIR}/examples)

add_custom_target(run_all_examples_under_valgrind
	COMMAND ${CMAKE_SOURCE_DIR}/examples/run-all-examples.sh ${CMAKE_BINARY_DIR}/examples --valgrind)

add_custom_target(run_all_examples_with_fault_injection
	COMMAND ${CMAKE_SOURCE_DIR}/examples/run-all-examples.sh ${CMAKE_BINARY_DIR}/examples --integration-tests)

=== examples/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2018-2022, Intel Corporation
# Copyright 2021-2022, Fujitsu
#

add_flag(-Wall)
add_flag(-Wpointer-arith)
add_flag(-Wsign-compare)
add_flag(-Wunreachable-code-return)
add_flag(-Wmissing-variable-declarations)
add_flag(-fno-common)
add_flag(-Wunused-macros)
add_flag(-Wsign-conversion)

add_flag(-ggdb DEBUG)
add_flag(-DDEBUG DEBUG)

add_flag("-U_FORTIFY_SOURCE -D_FORTIFY_SOURCE=2" RELEASE)

include(${CMAKE_SOURCE_DIR}/cmake/functions.cmake)
# set LIBRT_LIBRARIES if linking with librt is required
check_if_librt_is_required()

add_custom_target(examples)
include_directories(${LIBRPMA_INCLUDE_DIRS})
link_directories(${LIBRPMA_LIBRARY_DIRS})

file(GLOB src_files ${CMAKE_CURRENT_SOURCE_DIR}/*/*.[ch])

# Filter out protobuf-c generated files.
# Starting from CMake v3.6 we could use:
#    list(FILTER src_files EXCLUDE REGEX ".*(pb-c).*")
# but we require CMake v3.3, so we have to do it
# in the following way:
foreach(file IN LISTS src_files)
	if(NOT file MATCHES ".*(pb-c).*")
		set(rpma_src_files "${file};${rpma_src_files}")
	endif()
endforeach()

add_cstyle(examples-all ${rpma_src_files})
add_check_whitespace(examples-all ${rpma_src_files})

function(add_example)
	set(options USE_LIBPROTOBUFC)
	set(oneValueArgs NAME BIN)
	set(multiValueArgs SRCS)
	cmake_parse_arguments(EXAMPLE
		"${options}"
		"${oneValueArgs}"
		"${multiValueArgs}"
		${ARGN})

	set(target example-${EXAMPLE_NAME}-${EXAMPLE_BIN})

	if (EXAMPLE_USE_LIBPROTOBUFC AND NOT LIBPROTOBUFC_FOUND)
		message(STATUS "${target} skipped - no libprotobuf-c found")
		return()
	endif()

	prepend(srcs ${CMAKE_CURRENT_SOURCE_DIR} ${srcs})

	set(EXAMPLE_SRCS ${EXAMPLE_SRCS} common/common-conn.c)
	if (LIBPMEM_FOUND OR LIBPMEM2_FOUND)
		set(EXAMPLE_SRCS ${EXAMPLE_SRCS}
			common/common-map_file_with_signature_check.c common/common-hello.c)
	endif()
	if (LIBPMEM2_FOUND)
		add_executable(${target} ${EXAMPLE_SRCS} common/common-pmem2_map_file.c)
	elseif (LIBPMEM_FOUND)
		add_executable(${target} ${EXAMPLE_SRCS} common/common-pmem_map_file.c)
	else()
		add_executable(${target} ${EXAMPLE_SRCS})
	endif()
	add_dependencies(examples ${target})
	set_target_properties(${target} PROPERTIES
		OUTPUT_NAME ${EXAMPLE_BIN}
		RUNTIME_OUTPUT_DIRECTORY ${EXAMPLE_NAME})
	target_link_libraries(${target} ${LIBRPMA_LIBRARIES} ${LIBRT_LIBRARIES}
		${LIBIBVERBS_LIBRARIES})
	target_include_directories(${target} PRIVATE common
		${LIBRPMA_SOURCE_DIR} ${LIBIBVERBS_INCLUDE_DIRS})

	if(LIBPMEM2_FOUND)
		target_include_directories(${target}
			PRIVATE ${LIBPMEM2_INCLUDE_DIRS})
		target_link_libraries(${target} ${LIBPMEM2_LIBRARIES})
		target_compile_definitions(${target}
			PRIVATE USE_LIBPMEM2)
	elseif(LIBPMEM_FOUND)
		target_include_directories(${target}
			PRIVATE ${LIBPMEM_INCLUDE_DIRS})
		target_link_libraries(${target} ${LIBPMEM_LIBRARIES})
		target_compile_definitions(${target}
			PRIVATE USE_LIBPMEM)
	endif()

	if(EXAMPLE_USE_LIBPROTOBUFC)
		target_include_directories(${target}
			PRIVATE ${LIBPROTOBUFC_INCLUDE_DIRS})
		target_link_libraries(${target} ${LIBPROTOBUFC_LIBRARIES})
	endif()

	if(IBV_ADVISE_MR_FLAGS_SUPPORTED)
		target_compile_definitions(${target} PRIVATE IBV_ADVISE_MR_FLAGS_SUPPORTED=1)
	endif()
endfunction()

add_example(NAME template BIN template
	SRCS template-example/template-example.c)
add_example(NAME 01-connection BIN server
	SRCS 01-connection/server.c)
add_example(NAME 01-connection BIN client
	SRCS 01-connection/client.c)
add_example(NAME 02-read-to-volatile BIN server
	SRCS 02-read-to-volatile/server.c)
add_example(NAME 02-read-to-volatile BIN client
	SRCS 02-read-to-volatile/client.c)
add_example(NAME 03-read-to-persistent BIN server
	SRCS 03-read-to-persistent/server.c)
add_example(NAME 03-read-to-persistent BIN client
	SRCS 03-read-to-persistent/client.c common/common-hello.c)
add_example(NAME 04-write-to-persistent BIN server
	SRCS 04-write-to-persistent/server.c common/common-hello.c)
add_example(NAME 04-write-to-persistent BIN client
	SRCS 04-write-to-persistent/client.c common/common-hello.c)
add_example(NAME 05-flush-to-persistent BIN server
	SRCS 05-flush-to-persistent/server.c common/common-hello.c)
add_example(NAME 05-flush-to-persistent BIN client
	SRCS 05-flush-to-persistent/client.c common/common-hello.c)
add_example(NAME 06-multiple-connections BIN server
	SRCS 06-multiple-connections/server.c common/common-epoll.c)
add_example(NAME 06-multiple-connections BIN client
	SRCS 06-multiple-connections/client.c)
add_example(NAME 06scch-multiple-connections BIN server
	SRCS 06scch-multiple-connections/server.c common/common-epoll.c)
add_example(NAME 06scch-multiple-connections BIN client
	SRCS 06scch-multiple-connections/client.c)
add_example(NAME 07-atomic-write BIN server
	SRCS 07-atomic-write/server.c)
add_example(NAME 07-atomic-write BIN client
	SRCS 07-atomic-write/client.c)
add_example(NAME 08-messages-ping-pong BIN server
	SRCS 08-messages-ping-pong/server.c common/common-messages-ping-pong.c)
add_example(NAME 08-messages-ping-pong BIN client
	SRCS 08-messages-ping-pong/client.c common/common-messages-ping-pong.c common/common-utils.c)
add_example(NAME 08srq-simple-messages-ping-pong-with-srq BIN server
	SRCS 08srq-simple-messages-ping-pong-with-srq/server.c common/common-messages-ping-pong.c)
add_example(NAME 08srq-simple-messages-ping-pong-with-srq BIN client
	SRCS 08srq-simple-messages-ping-pong-with-srq/client.c common/common-messages-ping-pong.c common/common-utils.c)
add_example(NAME 09-flush-to-persistent-GPSPM BIN server USE_LIBPROTOBUFC
	SRCS 09-flush-to-persistent-GPSPM/server.c
	09-flush-to-persistent-GPSPM/GPSPM_flush.pb-c.c common/common-hello.c)
add_example(NAME 09-flush-to-persistent-GPSPM BIN client USE_LIBPROTOBUFC
	SRCS 09-flush-to-persistent-GPSPM/client.c
	09-flush-to-persistent-GPSPM/GPSPM_flush.pb-c.c common/common-hello.c)
add_example(NAME 09scch-flush-to-persistent-GPSPM BIN server USE_LIBPROTOBUFC
	SRCS 09scch-flush-to-persistent-GPSPM/server.c
	09scch-flush-to-persistent-GPSPM/GPSPM_flush.pb-c.c common/common-hello.c)
add_example(NAME 09scch-flush-to-persistent-GPSPM BIN client USE_LIBPROTOBUFC
	SRCS 09scch-flush-to-persistent-GPSPM/client.c
	09scch-flush-to-persistent-GPSPM/GPSPM_flush.pb-c.c common/common-hello.c)
add_example(NAME 10-send-with-imm BIN server
	SRCS 10-send-with-imm/server.c)
add_example(NAME 10-send-with-imm BIN client
	SRCS 10-send-with-imm/client.c)
add_example(NAME 11-write-with-imm BIN server
	SRCS 11-write-with-imm/server.c)
add_example(NAME 11-write-with-imm BIN client
	SRCS 11-write-with-imm/client.c)
add_example(NAME 12-receive-completion-queue BIN server
	SRCS 12-receive-completion-queue/server.c
	12-receive-completion-queue/receive-completion-queue-common.c)
add_example(NAME 12-receive-completion-queue BIN client
	SRCS 12-receive-completion-queue/client.c
	12-receive-completion-queue/receive-completion-queue-common.c common/common-utils.c)
add_example(NAME 12scch-receive-completion-queue BIN server
	SRCS 12scch-receive-completion-queue/server.c)
add_example(NAME 12scch-receive-completion-queue BIN client
	SRCS 12scch-receive-completion-queue/client.c common/common-utils.c)
add_example(NAME 13-messages-ping-pong-with-srq BIN server
	SRCS 13-messages-ping-pong-with-srq/server.c common/common-epoll.c)
add_example(NAME 13-messages-ping-pong-with-srq BIN client
	SRCS 13-messages-ping-pong-with-srq/client.c common/common-messages-ping-pong.c common/common-utils.c)

add_example(NAME log BIN log SRCS
	log/log-example.c
	log/log-worker.c
	${LIBRPMA_SOURCE_DIR}/log.c
	${LIBRPMA_SOURCE_DIR}/log_default.c)

add_library(doc_snippets_template-snippet OBJECT doc_snippets/template-snippet.c)

=== src/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2022, Intel Corporation
# Copyright 2021-2022, Fujitsu
#

add_cstyle(src
	${CMAKE_CURRENT_SOURCE_DIR}/*.[ch]
	${CMAKE_CURRENT_SOURCE_DIR}/include/*.h)

add_check_whitespace(src
	${CMAKE_CURRENT_SOURCE_DIR}/*.[ch]
	${CMAKE_CURRENT_SOURCE_DIR}/include/*.h)

set(SOURCES
	conn.c
	conn_cfg.c
	conn_req.c
	cq.c
	debug.c
	ep.c
	flush.c
	info.c
	librpma.c
	log.c
	log_default.c
	mr.c
	peer.c
	peer_cfg.c
	private_data.c
	rpma_err.c
	utils.c
	srq.c
	srq_cfg.c)

add_library(rpma SHARED ${SOURCES})

target_include_directories(rpma PRIVATE . include)

target_link_libraries(rpma PRIVATE
	${LIBIBVERBS_LIBRARIES}
	${LIBRDMACM_LIBRARIES}
	-Wl,--version-script=${CMAKE_SOURCE_DIR}/src/librpma.map)

set_target_properties(rpma PROPERTIES
	SOVERSION 0
	PUBLIC_HEADER "include/librpma.h")

target_compile_definitions(rpma PRIVATE SRCVERSION="${SRCVERSION}")

if(DEBUG_LOG_TRACE)
	target_compile_definitions(rpma PRIVATE DEBUG_LOG_TRACE=1)
endif()

if(DEBUG_FAULT_INJECTION)
	target_compile_definitions(rpma PRIVATE DEBUG_FAULT_INJECTION=1)
endif()

if(VALGRIND_FOUND)
	target_include_directories(rpma PRIVATE src/valgrind)
endif()

if(IBV_ADVISE_MR_FLAGS_SUPPORTED)
	target_compile_definitions(rpma PRIVATE IBV_ADVISE_MR_FLAGS_SUPPORTED=1)
endif()

install(TARGETS rpma
	PUBLIC_HEADER DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}
	LIBRARY DESTINATION ${CMAKE_INSTALL_LIBDIR}
	RUNTIME DESTINATION ${CMAKE_INSTALL_BINDIR})

=== examples/03-read-to-persistent/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2022, Intel Corporation
# Copyright 2021, Fujitsu
#

cmake_minimum_required(VERSION 3.3)
project(read-to-persistent C)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
	${CMAKE_SOURCE_DIR}/../cmake
	${CMAKE_SOURCE_DIR}/../../cmake)

include(${CMAKE_SOURCE_DIR}/../cmake/common.cmake)
include(${CMAKE_SOURCE_DIR}/../../cmake/functions.cmake)

# check if all required IBV_ADVISE_MR* flags are supported
are_ibv_advise_flags_supported(IBV_ADVISE_MR_FLAGS_SUPPORTED)

# set LIBRT_LIBRARIES if linking with librt is required
check_if_librt_is_required()

set(LIBPMEM_REQUIRED_VERSION 1.6)

find_package(PkgConfig QUIET)

if(PKG_CONFIG_FOUND)
	pkg_check_modules(LIBRPMA librpma)
	pkg_check_modules(LIBIBVERBS libibverbs)
	pkg_check_modules(LIBPMEM QUIET libpmem>=${LIBPMEM_REQUIRED_VERSION})
endif()
if(NOT LIBRPMA_FOUND)
	find_package(LIBRPMA REQUIRED librpma)
endif()
if(NOT LIBIBVERBS_FOUND)
	find_package(LIBIBVERBS REQUIRED libibverbs)
endif()
if(NOT LIBPMEM_FOUND)
	find_package(LIBPMEM ${LIBPMEM_REQUIRED_VERSION} QUIET)
endif()

link_directories(${LIBRPMA_LIBRARY_DIRS})

add_example_with_pmem(NAME server SRCS server.c)
add_example_with_pmem(NAME client SRCS client.c)

=== examples/04-write-to-persistent/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2022, Intel Corporation
# Copyright 2021, Fujitsu
#

cmake_minimum_required(VERSION 3.3)
project(write-to-persistent C)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
	${CMAKE_SOURCE_DIR}/../cmake
	${CMAKE_SOURCE_DIR}/../../cmake)

include(${CMAKE_SOURCE_DIR}/../cmake/common.cmake)
include(${CMAKE_SOURCE_DIR}/../../cmake/functions.cmake)

# check if all required IBV_ADVISE_MR* flags are supported
are_ibv_advise_flags_supported(IBV_ADVISE_MR_FLAGS_SUPPORTED)

# set LIBRT_LIBRARIES if linking with librt is required
check_if_librt_is_required()

set(LIBPMEM_REQUIRED_VERSION 1.6)

find_package(PkgConfig QUIET)

if(PKG_CONFIG_FOUND)
	pkg_check_modules(LIBRPMA librpma)
	pkg_check_modules(LIBIBVERBS libibverbs)
	pkg_check_modules(LIBPMEM QUIET libpmem>=${LIBPMEM_REQUIRED_VERSION})
endif()
if(NOT LIBRPMA_FOUND)
	find_package(LIBRPMA REQUIRED librpma)
endif()
if(NOT LIBIBVERBS_FOUND)
	find_package(LIBIBVERBS REQUIRED libibverbs)
endif()
if(NOT LIBPMEM_FOUND)
	find_package(LIBPMEM ${LIBPMEM_REQUIRED_VERSION} QUIET)
endif()

link_directories(${LIBRPMA_LIBRARY_DIRS})

add_example_with_pmem(NAME server SRCS server.c)
add_example_with_pmem(NAME client SRCS client.c)

=== examples/05-flush-to-persistent/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2022, Intel Corporation
# Copyright 2021, Fujitsu
#

cmake_minimum_required(VERSION 3.3)
project(flush-to-persistent C)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
	${CMAKE_SOURCE_DIR}/../cmake
	${CMAKE_SOURCE_DIR}/../../cmake)

include(${CMAKE_SOURCE_DIR}/../cmake/common.cmake)
include(${CMAKE_SOURCE_DIR}/../../cmake/functions.cmake)

# check if all required IBV_ADVISE_MR* flags are supported
are_ibv_advise_flags_supported(IBV_ADVISE_MR_FLAGS_SUPPORTED)

# set LIBRT_LIBRARIES if linking with librt is required
check_if_librt_is_required()

set(LIBPMEM_REQUIRED_VERSION 1.6)

find_package(PkgConfig QUIET)

if(PKG_CONFIG_FOUND)
	pkg_check_modules(LIBRPMA librpma)
	pkg_check_modules(LIBIBVERBS libibverbs)
	pkg_check_modules(LIBPMEM QUIET libpmem>=${LIBPMEM_REQUIRED_VERSION})
endif()
if(NOT LIBRPMA_FOUND)
	find_package(LIBRPMA REQUIRED librpma)
endif()
if(NOT LIBIBVERBS_FOUND)
	find_package(LIBIBVERBS REQUIRED libibverbs)
endif()
if(NOT LIBPMEM_FOUND)
	find_package(LIBPMEM ${LIBPMEM_REQUIRED_VERSION} QUIET)
endif()

link_directories(${LIBRPMA_LIBRARY_DIRS})

add_example_with_pmem(NAME server SRCS server.c)
add_example_with_pmem(NAME client SRCS client.c)

=== examples/09-flush-to-persistent-GPSPM/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2022, Intel Corporation
# Copyright 2021, Fujitsu
#

cmake_minimum_required(VERSION 3.3)
project(flush-to-persistent C)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
	${CMAKE_SOURCE_DIR}/../cmake
	${CMAKE_SOURCE_DIR}/../../cmake)

include(${CMAKE_SOURCE_DIR}/../cmake/common.cmake)
include(${CMAKE_SOURCE_DIR}/../../cmake/functions.cmake)

# check if all required IBV_ADVISE_MR* flags are supported
are_ibv_advise_flags_supported(IBV_ADVISE_MR_FLAGS_SUPPORTED)

# set LIBRT_LIBRARIES if linking with librt is required
check_if_librt_is_required()

set(LIBPMEM_REQUIRED_VERSION 1.6)

find_package(PkgConfig QUIET)

if(PKG_CONFIG_FOUND)
	pkg_check_modules(LIBRPMA librpma)
	pkg_check_modules(LIBIBVERBS libibverbs)
	pkg_check_modules(LIBPROTOBUFC libprotobuf-c)
	pkg_check_modules(LIBPMEM QUIET libpmem>=${LIBPMEM_REQUIRED_VERSION})
endif()
if(NOT LIBRPMA_FOUND)
	find_package(LIBRPMA REQUIRED librpma)
endif()
if(NOT LIBIBVERBS_FOUND)
	find_package(LIBIBVERBS REQUIRED libibverbs)
endif()
if(NOT LIBPROTOBUFC_FOUND)
	find_package(LIBPROTOBUFC REQUIRED libprotobuf-c)
endif()
if(NOT LIBPMEM_FOUND)
	find_package(LIBPMEM ${LIBPMEM_REQUIRED_VERSION} QUIET)
endif()

link_directories(${LIBRPMA_LIBRARY_DIRS})

add_example_with_pmem(NAME server USE_LIBPROTOBUFC SRCS server.c GPSPM_flush.pb-c.c)
add_example_with_pmem(NAME client USE_LIBPROTOBUFC SRCS client.c GPSPM_flush.pb-c.c)

=== tests/unit/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020, Intel Corporation
# Copyright 2021-2022, Fujitsu
#

add_subdirectory(conn)
add_subdirectory(conn_cfg)
add_subdirectory(conn_req)
add_subdirectory(cq)
add_subdirectory(ep)
add_subdirectory(error)
add_subdirectory(flush)
add_subdirectory(info)
add_subdirectory(librpma_constructor)
add_subdirectory(log)
add_subdirectory(mr)
add_subdirectory(peer)
add_subdirectory(peer_cfg)
add_subdirectory(private_data)
add_subdirectory(srq)
add_subdirectory(srq_cfg)
add_subdirectory(template)
add_subdirectory(utils)

if(TESTS_NO_FORTIFY_SOURCE)
	add_subdirectory(log_default)
endif()

=== tools/perf/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2021-2022, Intel Corporation
#

add_cstyle_pep8(tools_perf
	# XXX requires adding pytest to all CI images
	# ${CMAKE_CURRENT_SOURCE_DIR}/tests/*.py
	# ${CMAKE_CURRENT_SOURCE_DIR}/tests/*/*.py
	# ${CMAKE_CURRENT_SOURCE_DIR}/tests/*/*/*.py
	# ${CMAKE_CURRENT_SOURCE_DIR}/tests/*/*/*/*.py
	${CMAKE_CURRENT_SOURCE_DIR}/report_bench.py
	${CMAKE_CURRENT_SOURCE_DIR}/report_create.py 
	${CMAKE_CURRENT_SOURCE_DIR}/report_figures.py
	${CMAKE_CURRENT_SOURCE_DIR}/lib/__init__.py
	${CMAKE_CURRENT_SOURCE_DIR}/lib/bench.py
	${CMAKE_CURRENT_SOURCE_DIR}/lib/common.py
	${CMAKE_CURRENT_SOURCE_DIR}/lib/compare.py
	${CMAKE_CURRENT_SOURCE_DIR}/lib/remote_cmd.py
	${CMAKE_CURRENT_SOURCE_DIR}/lib/figure/*.py
	${CMAKE_CURRENT_SOURCE_DIR}/lib/format/*.py
	${CMAKE_CURRENT_SOURCE_DIR}/lib/benchmark/*.py
	${CMAKE_CURRENT_SOURCE_DIR}/lib/benchmark/runner/*.py
	${CMAKE_CURRENT_SOURCE_DIR}/lib/report/*.py
	${CMAKE_CURRENT_SOURCE_DIR}/tests/lib/benchmark/*.py
	${CMAKE_CURRENT_SOURCE_DIR}/tests/lib/benchmark/runner/*.py)

=== tests/unit/template/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2022, Intel Corporation
#

include(../../cmake/ctest_helpers.cmake)

build_test_lib(template template.c)
add_test_generic(NAME ut-template TRACERS none)

=== tests/unit/utils/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2022, Intel Corporation
#

include(../../cmake/ctest_helpers.cmake)

build_test_src(UNIT NAME ut-utils-conn_event_2str SRCS
	utils-conn_event_2str.c
	${TEST_UNIT_COMMON_DIR}/mocks-ibverbs.c
	${TEST_UNIT_COMMON_DIR}/mocks-rdma_cm.c
	${TEST_UNIT_COMMON_DIR}/mocks-rpma-info.c
	${TEST_UNIT_COMMON_DIR}/mocks-rpma-log.c
	${LIBRPMA_SOURCE_DIR}/rpma_err.c
	${LIBRPMA_SOURCE_DIR}/utils.c)

build_test_src(UNIT NAME ut-utils-get_ibv_context SRCS
	utils-get_ibv_context.c
	utils-common.c
	${TEST_UNIT_COMMON_DIR}/mocks-ibverbs.c
	${TEST_UNIT_COMMON_DIR}/mocks-rpma-log.c
	${LIBRPMA_SOURCE_DIR}/rpma_err.c
	${LIBRPMA_SOURCE_DIR}/utils.c)

add_test_generic(NAME ut-utils-conn_event_2str TRACERS none)
add_test_generic(NAME ut-utils-get_ibv_context TRACERS none)

if(ON_DEMAND_PAGING_SUPPORTED)
	build_test_src(UNIT NAME ut-utils-ibv_context_is_odp_capable SRCS
		utils-ibv_context_is_odp_capable.c
		${TEST_UNIT_COMMON_DIR}/mocks-ibverbs.c
		${TEST_UNIT_COMMON_DIR}/mocks-rdma_cm.c
		${TEST_UNIT_COMMON_DIR}/mocks-rpma-info.c
		${TEST_UNIT_COMMON_DIR}/mocks-rpma-log.c
		${LIBRPMA_SOURCE_DIR}/rpma_err.c
		${LIBRPMA_SOURCE_DIR}/utils.c)

	add_test_generic(NAME ut-utils-ibv_context_is_odp_capable TRACERS none)
endif()

=== debian/changelog ===
rpma (1.0.0-1) unstable; urgency=medium

  * The "it's perfect now!" upstream release.
  * Symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 25 Aug 2022 13:10:06 +0200

rpma (0.14.0-1) experimental; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 16 Mar 2022 16:26:04 +0100

rpma (0.13.0-1) experimental; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 16 Mar 2022 16:11:45 +0100

rpma (0.12.0-1) experimental; urgency=medium

  * New upstream release.
  * Reenable +fortify.
  * B-Depend on valgrind-if-available.
  * Drop the symbols file for now.

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 22 Feb 2022 14:26:02 +0100

rpma (0.11.0-1) experimental; urgency=medium

  * New upstream release.
  * Replace symbols.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 11 Feb 2022 09:39:12 +0100

rpma (0.10.0-1) experimental; urgency=medium

  * New upstream release.
  * Disable RoCE tests.
  * Add new B-Deps.
  * Enable riscv64.
  * Add a watch file.

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 26 Jan 2022 08:49:33 +0100

rpma (0.9.0-1) experimental; urgency=medium

  * Initial release (Closes: #971512)

 -- Adam Borowski <kilobyte@angband.pl>  Wed, 21 Oct 2020 06:23:36 +0200

=== debian/control ===
Source: rpma
Priority: optional
Maintainer: Adam Borowski <kilobyte@angband.pl>
Build-Depends: debhelper-compat (= 13),
	cmake,
	libibverbs-dev,
	librdmacm-dev,
	libcmocka-dev,
	groff,
	txt2man,
	pkg-config,
	libprotobuf-c-dev,
	pandoc,
	libunwind-dev [!riscv64],
	libpmem-dev,
	libpmem2-dev,
	valgrind-if-available,
	pylint,
Standards-Version: 4.6.1
Section: libs
Homepage: https://github.com/pmem/rpma
Vcs-Browser: https://github.com/kilobyte/rpma
Vcs-Git: https://github.com/kilobyte/rpma
Rules-Requires-Root: no

Package: librpma-dev
Section: libdevel
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: librpma0 (= ${binary:Version}), ${misc:Depends}
Description: remote pmem access library (headers)
 The Remote Persistent Memory Access (RPMA) is a C library to simplify
 accessing persistent memory devices on remote hosts over Remote Direct
 Memory Access (RDMA).
 .
 This package includes development headers and documentation.

Package: librpma0
Architecture: amd64 arm64 ppc64el riscv64
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: remote pmem access library (runtime)
 The Remote Persistent Memory Access (RPMA) is a C library to simplify
 accessing persistent memory devices on remote hosts over Remote Direct
 Memory Access (RDMA).
 .
 This package includes the runtime library.

## rpma 1.2.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,7 @@
 #
 # SPDX-License-Identifier: BSD-3-Clause
-# Copyright 2020-2022, Intel Corporation
+# Copyright 2020-2023, Intel Corporation
+# Copyright (c) 2022 Fujitsu Limited
 #
 
 cmake_minimum_required(VERSION 3.3)
@@ -8,7 +9,7 @@
 project(rpma C)
 
 set(VERSION_MAJOR 1)
-set(VERSION_MINOR 0)
+set(VERSION_MINOR 2)
 set(VERSION_PATCH 0)
 # set(VERSION_PRERELEASE rc1)
 
@@ -41,7 +42,6 @@
 
 option(TESTS_COVERAGE "run coverage test" OFF)
 option(TESTS_NO_FORTIFY_SOURCE "enable tests that do not pass when -D_FORTIFY_SOURCE=2 flag set" OFF)
-option(TESTS_PERF_TOOLS "run tests for the performance analysis tools" OFF)
 option(TESTS_RDMA_CONNECTION "enable tests that require a configured RDMA-capable network interface (valgrind required)" OFF)
 option(TESTS_USE_FORCED_PMEM "run tests with PMEM_IS_PMEM_FORCE=1" OFF)
 option(TESTS_USE_VALGRIND_PMEMCHECK "enable tests with valgrind pmemcheck (if found)" OFF)
@@ -179,6 +179,15 @@
 	message(WARNING "atomic operations are NOT supported (too old gcc/clang compiler). Some *_set*() functions will NOT be thread-safe!")
 endif()
 
+# check if libibverbs has ibv_wr_atomic_write() support
+is_ibv_wr_atomic_write_supported(IBV_WR_ATOMIC_WRITE_SUPPORTED)
+if(IBV_WR_ATOMIC_WRITE_SUPPORTED)
+	message(STATUS "ibv_wr_atomic_write() supported in libibverbs - Success")
+	add_flag(-DIBV_WR_ATOMIC_WRITE_SUPPORTED=1)
+else()
+	message(WARNING "ibv_wr_atomic_write() is NOT supported and will be disabled (too old version of libibverbs)!")
+endif()
+
 add_custom_target(checkers ALL)
 add_custom_target(cstyle)
 add_custom_target(check-whitespace)
@@ -312,11 +321,6 @@
 	add_subdirectory(examples)
 endif()
 
-if(TESTS_PERF_TOOLS)
-	find_package(PYLINT REQUIRED pylint)
-	add_subdirectory(tools/perf)
-endif()
-
 if(NOT "${CPACK_GENERATOR}" STREQUAL "")
 	include(${CMAKE_SOURCE_DIR}/cmake/packages.cmake)
 endif()

=== doc/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2019-2021, Intel Corporation
#

find_program(SRC2MAN NAMES src2man)
find_program(GROFF NAMES groff)
find_program(FIND NAMES find)
find_program(DIFF NAMES diff)
find_program(GAWK NAMES gawk) # required by src2man

find_program(PANDOC NAMES pandoc)
if(NOT PANDOC)
	message(WARNING "pandoc not found - Markdown documentation will not be generated")
endif()

if(SRC2MAN AND GROFF AND FIND AND DIFF AND GAWK)
	# create man pages from sources
	set(man3_list ${CMAKE_SOURCE_DIR}/doc/manuals_3.txt)
	set(man7_list ${CMAKE_SOURCE_DIR}/doc/manuals_7.txt)

	add_custom_target(doc ALL 
		COMMAND ${CMAKE_SOURCE_DIR}/utils/src2mans.sh
			${CMAKE_SOURCE_DIR}/src ${man3_list} ${man7_list}
			${CMAKE_SOURCE_DIR}/utils/mans_header.md)

	add_custom_target(doc-fix
		COMMAND ${CMAKE_SOURCE_DIR}/utils/src2mans.sh
			${CMAKE_SOURCE_DIR}/src ${man3_list} ${man7_list}
			${CMAKE_SOURCE_DIR}/utils/mans_header.md
			fix)

	file(STRINGS ${man3_list} man3)
	file(STRINGS ${man7_list} man7)

	#
	# It is just:
	#    list(TRANSFORM man3 PREPEND "${CMAKE_CURRENT_BINARY_DIR}/")
	# but 'list(TRANSFORM' requires CMake>=v3.12
	#
	set(new_man3 "")
	foreach(item IN LISTS man3)
		set(new_man3 "${CMAKE_CURRENT_BINARY_DIR}/${item};${new_man3}")
	endforeach()

	set(new_man7 "")
	foreach(item IN LISTS man7)
		set(new_man7 "${CMAKE_CURRENT_BINARY_DIR}/${item};${new_man7}")
	endforeach()

	# install manpages
	install(FILES ${new_man3}
		DESTINATION ${CMAKE_INSTALL_MANDIR}/man3)
	install(FILES ${new_man7}
		DESTINATION ${CMAKE_INSTALL_MANDIR}/man7)
else()
	if(NOT SRC2MAN)
		message(WARNING "src2man not found - man pages will not be generated")
	endif()
	if(NOT GROFF)
		message(WARNING "groff not found - man pages will not be generated")
	endif()
	if(NOT FIND)
		message(WARNING "find not found - man pages will not be generated")
	endif()
	if(NOT DIFF)
		message(WARNING "diff not found - man pages will not be generated")
	endif()
	if(NOT GAWK)
		message(WARNING "gawk not found - man pages will not be generated")
	endif()
endif()

=== examples/09-flush-to-persistent-GPSPM/CMakeLists.txt ===
--- 
+++ 
@@ -45,5 +45,5 @@
 
 link_directories(${LIBRPMA_LIBRARY_DIRS})
 
-add_example_with_pmem(NAME server USE_LIBPROTOBUFC SRCS server.c GPSPM_flush.pb-c.c)
-add_example_with_pmem(NAME client USE_LIBPROTOBUFC SRCS client.c GPSPM_flush.pb-c.c)
+add_example_with_pmem(NAME server USE_LIBPROTOBUFC SRCS server.c ../common/gpspm/GPSPM_flush.pb-c.c)
+add_example_with_pmem(NAME client USE_LIBPROTOBUFC SRCS client.c ../common/gpspm/GPSPM_flush.pb-c.c ../common/common-utils.c)

=== examples/11-write-with-imm/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright (c) 2021 Fujitsu
#

cmake_minimum_required(VERSION 3.3)
project(write-with-imm C)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
	${CMAKE_SOURCE_DIR}/../cmake
	${CMAKE_SOURCE_DIR}/../../cmake)

include(${CMAKE_SOURCE_DIR}/../../cmake/functions.cmake)
# set LIBRT_LIBRARIES if linking with librt is required
check_if_librt_is_required()

find_package(PkgConfig QUIET)

if(PKG_CONFIG_FOUND)
	pkg_check_modules(LIBRPMA librpma)
	pkg_check_modules(LIBIBVERBS libibverbs)
endif()
if(NOT LIBRPMA_FOUND)
	find_package(LIBRPMA REQUIRED librpma)
endif()
if(NOT LIBIBVERBS_FOUND)
	find_package(LIBIBVERBS REQUIRED libibverbs)
endif()

link_directories(${LIBRPMA_LIBRARY_DIRS} ${LIBIBVERBS_LIBRARY_DIRS})

function(add_example name)
	set(srcs ${ARGN})
	add_executable(${name} ${srcs})
	target_include_directories(${name}
		PRIVATE
			${LIBRPMA_INCLUDE_DIRS}
			${LIBIBVERBS_INCLUDE_DIRS}
			../common)
	target_link_libraries(${name} rpma ${LIBIBVERBS_LIBRARIES} ${LIBRT_LIBRARIES})
endfunction()

add_example(server server.c ../common/common-conn.c)
add_example(client client.c ../common/common-conn.c)

=== examples/12-receive-completion-queue/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2022, Intel Corporation
#

cmake_minimum_required(VERSION 3.3)
project(receive-completion-queue C)

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH}
	${CMAKE_SOURCE_DIR}/../cmake
	${CMAKE_SOURCE_DIR}/../../cmake)

include(${CMAKE_SOURCE_DIR}/../../cmake/functions.cmake)
# set LIBRT_LIBRARIES if linking with librt is required
check_if_librt_is_required()

find_package(PkgConfig QUIET)

if(PKG_CONFIG_FOUND)
	pkg_check_modules(LIBRPMA librpma)
	pkg_check_modules(LIBIBVERBS libibverbs)
endif()
if(NOT LIBRPMA_FOUND)
	find_package(LIBRPMA REQUIRED librpma)
endif()
if(NOT LIBIBVERBS_FOUND)
	find_package(LIBIBVERBS REQUIRED libibverbs)
endif()

link_directories(${LIBRPMA_LIBRARY_DIRS} ${LIBIBVERBS_LIBRARY_DIRS})

function(add_example name)
	set(srcs ${ARGN})
	add_executable(${name} ${srcs})
	target_include_directories(${name}
		PRIVATE
			${LIBRPMA_INCLUDE_DIRS}
			${LIBIBVERBS_INCLUDE_DIRS}
			../common)
	target_link_libraries(${name} rpma ${LIBIBVERBS_LIBRARIES} ${LIBRT_LIBRARIES})
endfunction()

add_example(server server.c ../common/common-conn.c receive-completion-queue-common.c)
add_example(client client.c ../common/common-conn.c receive-completion-queue-common.c ../common/common-utils.c)

=== tests/multithreaded/log/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2022, Intel Corporation
#

include(../../cmake/ctest_helpers.cmake)

add_multithreaded(NAME log BIN rpma_log_set_function
	SRCS rpma_log_set_function.c)
add_multithreaded(NAME log BIN rpma_log_set_threshold
	SRCS rpma_log_set_threshold.c)
add_multithreaded(NAME log BIN rpma_log_set_get_threshold
	SRCS rpma_log_set_get_threshold.c)

=== tests/multithreaded/srq_cfg/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2022, Intel Corporation
#

include(../../cmake/ctest_helpers.cmake)

add_multithreaded(NAME srq_cfg BIN get_rcq_size
	SRCS rpma_srq_cfg_get_rcq_size.c rpma_srq_cfg_common.c)
add_multithreaded(NAME srq_cfg BIN get_rq_size
	SRCS rpma_srq_cfg_get_rq_size.c rpma_srq_cfg_common.c)
add_multithreaded(NAME srq_cfg BIN new
	SRCS rpma_srq_cfg_new.c)
add_multithreaded(NAME srq_cfg BIN set_rcq_size
	SRCS rpma_srq_cfg_set_rcq_size.c rpma_srq_cfg_common.c)
add_multithreaded(NAME srq_cfg BIN set_rq_size
	SRCS rpma_srq_cfg_set_rq_size.c rpma_srq_cfg_common.c)

=== tests/unit/error/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2022, Intel Corporation
#

include(../../cmake/ctest_helpers.cmake)

build_test_src(UNIT NAME ut-error SRCS
	error.c
	${LIBRPMA_SOURCE_DIR}/rpma_err.c)

add_test_generic(NAME ut-error TRACERS none)

=== tests/unit/flush/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2022, Intel Corporation
#

include(../../cmake/ctest_helpers.cmake)

function(add_test_flush name)
	set(src_name flush-${name})
	set(name ut-${src_name})
	build_test_src(UNIT NAME ${name} SRCS
		${src_name}.c
		flush-common.c
		${LIBRPMA_SOURCE_DIR}/rpma_err.c
		${LIBRPMA_SOURCE_DIR}/flush.c
		${TEST_UNIT_COMMON_DIR}/mocks-ibverbs.c
		${TEST_UNIT_COMMON_DIR}/mocks-rpma-log.c
		${TEST_UNIT_COMMON_DIR}/mocks-rpma-mr.c
		${TEST_UNIT_COMMON_DIR}/mocks-stdlib.c
		${TEST_UNIT_COMMON_DIR}/mocks-unistd.c)

	target_compile_definitions(${name} PRIVATE TEST_MOCK_ALLOC)

	set_target_properties(${name}
		PROPERTIES
		LINK_FLAGS "-Wl,--wrap=_test_malloc,--wrap=mmap,--wrap=munmap,--wrap=sysconf")

	add_test_generic(NAME ${name} TRACERS none)
endfunction()

add_test_flush(apm_execute)
add_test_flush(new)

=== tests/unit/log_default/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2022, Intel Corporation
#

include(../../cmake/ctest_helpers.cmake)

#
# Undefine _FORTIFY_SOURCE in the Release build.
# _FORTIFY_SOURCE replaces original '*printf' functions
# and causes cmocka mocks of those functions to not work.
#
add_flag("-U_FORTIFY_SOURCE" RELEASE)

function(build_log_default name)
	build_test_src(UNIT NAME ut-log_default-${name} SRCS
		${name}.c
		${TEST_UNIT_COMMON_DIR}/mocks-rpma-log.c
		${TEST_UNIT_COMMON_DIR}/mocks-stdio.c
		${TEST_UNIT_COMMON_DIR}/mocks-syslog.c
		${TEST_UNIT_COMMON_DIR}/mocks-time.c
		${TEST_UNIT_COMMON_DIR}/mocks-glibc.c
		${LIBRPMA_SOURCE_DIR}/log_default.c)

		set_target_properties(ut-log_default-${name} PROPERTIES
			LINK_FLAGS
			"-Wl,--wrap=vsnprintf,--wrap=snprintf,--wrap=fprintf,--wrap=clock_gettime,--wrap=localtime_r,--wrap=strftime,--wrap=syscall")

	add_test_generic(NAME ut-log_default-${name} TRACERS none)
endfunction()

build_log_default(init-fini)
build_log_default(function)

=== tests/unit/mr/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2022, Intel Corporation
#

include(../../cmake/ctest_helpers.cmake)

function(add_test_mr name)
	set(src_name mr-${name})
	set(name ut-${src_name})
	build_test_src(UNIT NAME ${name} SRCS
		${src_name}.c
		mr-common.c
		${TEST_UNIT_COMMON_DIR}/mocks-ibverbs.c
		${TEST_UNIT_COMMON_DIR}/mocks-rpma-log.c
		${TEST_UNIT_COMMON_DIR}/mocks-rpma-peer.c
		${TEST_UNIT_COMMON_DIR}/mocks-stdlib.c
		${LIBRPMA_SOURCE_DIR}/rpma_err.c
		${LIBRPMA_SOURCE_DIR}/mr.c)

	target_compile_definitions(${name} PRIVATE TEST_MOCK_ALLOC)

	set_target_properties(${name}
		PROPERTIES
		LINK_FLAGS "-Wl,--wrap=_test_malloc")

	add_test_generic(NAME ${name} TRACERS none)
endfunction()

add_test_mr(advise)
add_test_mr(atomic_write)
add_test_mr(descriptor)
add_test_mr(get_flush_type)
add_test_mr(local)
add_test_mr(read)
add_test_mr(recv)
add_test_mr(reg)
add_test_mr(send)
add_test_mr(srq_recv)
add_test_mr(write)

=== tests/unit/peer/CMakeLists.txt ===
#
# SPDX-License-Identifier: BSD-3-Clause
# Copyright 2020-2022, Intel Corporation
# Copyright 2021-2022, Fujitsu
#

include(../../cmake/ctest_helpers.cmake)

function(add_test_peer name)
	set(src_name peer-${name})
	set(name ut-${src_name})
	build_test_src(UNIT NAME ${name} SRCS
		${src_name}.c
		peer-common.c
		${TEST_UNIT_COMMON_DIR}/mocks-ibverbs.c
		${TEST_UNIT_COMMON_DIR}/mocks-rdma_cm.c
		${TEST_UNIT_COMMON_DIR}/mocks-rpma-conn_cfg.c
		${TEST_UNIT_COMMON_DIR}/mocks-rpma-cq.c
		${TEST_UNIT_COMMON_DIR}/mocks-rpma-log.c
		${TEST_UNIT_COMMON_DIR}/mocks-rpma-utils.c
		${TEST_UNIT_COMMON_DIR}/mocks-rpma-srq.c
		${TEST_UNIT_COMMON_DIR}/mocks-rpma-srq_cfg.c
		${TEST_UNIT_COMMON_DIR}/mocks-stdlib.c
		${LIBRPMA_SOURCE_DIR}/rpma_err.c
		${LIBRPMA_SOURCE_DIR}/peer.c)

	target_compile_definitions(${name} PRIVATE TEST_MOCK_ALLOC)

	set_target_properties(${name}
		PROPERTIES
		LINK_FLAGS "-Wl,--wrap=_test_malloc")

	add_test_generic(NAME ${name} TRACERS none)
endfunction()

add_test_peer(create_qp)
add_test_peer(create_srq)
add_test_peer(mr_reg)
add_test_peer(new)

=== debian/changelog ===
rpma (1.2.0-1) unstable; urgency=medium

  * New upstream release.
  * Change architecture to "any".

 -- Adam Borowski <kilobyte@angband.pl>  Tue, 10 Jan 2023 12:08:29 +0100

rpma (1.1.1-1) unstable; urgency=medium

  * New upstream release.
  * Undisable libunwind on riscv64.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 09 Jan 2023 15:12:28 +0100

rpma (1.1.0-1) unstable; urgency=medium

  * New upstream release.

 -- Adam Borowski <kilobyte@angband.pl>  Thu, 08 Sep 2022 10:24:59 +0200
